theory Argument_Filter_Impl
imports 
  Argument_Filter
  QDP_Framework_Impl
  Defaults
begin

definition
  argument_filter_tt :: "('tp, 'f::{show,key}, 'v) tp_ops \<Rightarrow> 'f afs_list \<Rightarrow> 'tp proc"
where
  "argument_filter_tt I pi tp \<equiv> do {
    check_permutation_afs pi;
    let \<pi> = af_rules (afs_list_to_afs pi);
    return (tp_ops.mk I default_nfs_trs [] (\<pi> (tp_ops.R I tp)) (\<pi> (tp_ops.Rw I tp)))
  }"

lemma argument_filter_tt:
  assumes I: "tp_spec I"
  shows "tp_spec.sound_tt_impl I (argument_filter_tt I pi)"
proof -
  interpret tp_spec I by fact
  show ?thesis
  proof
    fix tp tp'
    assume ok: "argument_filter_tt I pi tp = return tp'"
      and fin: "SN_qrel (qreltrs tp')"
    let ?Q = "set (Q tp)"
    let ?R = "set (R tp)"
    let ?S = "set (Rw tp)"
    let ?RS = "?R \<union> ?S"
    let ?pi = "afs_list_to_afs pi"
    let ?pir = "af_rules ?pi"
    from ok[unfolded argument_filter_tt_def Let_def, simplified]
    have ok: "isOK (check_permutation_afs pi)"
      and res: "tp' = mk default_nfs_trs [] (?pir (R tp)) (?pir (Rw tp))" by auto
    from fin res have "SN_rel (rstep (af_rule ?pi ` set (R tp))) (rstep (af_rule ?pi ` set (Rw tp)))" by simp
    from af_SN_relto_rstep[OF check_permutation_afs[OF ok] this[unfolded SN_rel_on_def]]
    have SN: "SN_qrel (NFS tp, {}, set (R tp), set (Rw tp))" by (simp add: SN_rel_on_def)
    show "SN_qrel (qreltrs tp)" unfolding qreltrs_sound
      by (rule SN_qrel_mono[OF _ _ _ SN], auto)
  qed
qed
end
