theory Complexity_Framework
imports 
  Complexity
  Q_Relative_Rewriting
begin
(* cpp problem *)
type_synonym ('f, 'v) cpp = 
"('f, 'v) trs \<times> ('f, 'v) trs \<times> ('f, 'v) terms \<times> ('f, 'v) complexity_measure" (* strict trs, weak trs, Q, start-terms *)


fun cpp_strict_trs :: "('f, 'v) cpp \<Rightarrow> ('f, 'v) trs"
  where 
    "cpp_strict_trs (S,_,_,_) = S"

fun cpp_weak_trs :: "('f, 'v) cpp \<Rightarrow> ('f, 'v) trs"
  where 
    "cpp_weak_trs (_,W,_,_) = W"


fun cpp_Q :: "('f, 'v) cpp \<Rightarrow> ('f, 'v) terms"
  where 
    "cpp_Q (_,_,Q,_) = Q"


fun cpp_start_terms :: "('f, 'v) cpp \<Rightarrow> ('f, 'v) complexity_measure"
  where 
    "cpp_start_terms (_,_,_,ST) = ST"

(* cpp reduction relation *)

fun cpp_qreltrs :: "('f, 'v) cpp \<Rightarrow> ('f, 'v) qreltrs"
  where 
"cpp_qreltrs cpp = (True, cpp_Q cpp, cpp_strict_trs cpp, cpp_weak_trs cpp)"

fun cpp_deriv :: "('f, 'v) cpp \<Rightarrow> ('f, 'v) term rel"
  where
   "cpp_deriv cpp = rel_qrstep (cpp_qreltrs cpp)"


(* dependency pair cdp *)

record ('f, 'v) dp_cpp = 
  dp_cpp_P :: "('f, 'v) trs"
  dp_cpp_Pw :: "('f, 'v) trs"
  dp_cpp_R :: "('f, 'v) trs"
  dp_cpp_Rw :: "('f, 'v) trs"
  dp_cpp_ST :: "('f, 'v) complexity_measure"
  dp_cpp_compounds :: "'f set"
end
